package nfjglbswft.examples.nqueens;

import apgas.Constructs;
import nfjglbswft.multiworker.NFJTask;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.concurrent.ConcurrentHashMap;

public class NQueensTask extends NFJTask<Long> implements Serializable {
    int continuation = 0;
    final int[] b;
    final int depth;

    HashMap<Long, Integer> childIDMap;
    ArrayList<Long> childResults;

    boolean atJoin;

    public NQueensTask(int[] b, int depth, NFJTask<Long> parentTask, long taskID) {
        super(parentTask, taskID);
        this.b = new int[b.length];
        System.arraycopy(b, 0, this.b, 0, b.length);
        this.depth = depth;
        this.childIDMap = new HashMap<>(1024);
        this.childResults = new ArrayList<>(1024);
        this.atJoin = false;
    }

    public NQueensTask(NQueensTask source) { // copy constructor
        super(source);
        this.continuation = source.continuation;
        this.b = source.b;
        this.depth = source.depth;
        this.childIDMap = source.childIDMap;
        this.childResults = source.childResults;
        this.atJoin = source.atJoin;
    }

    @Override
    public boolean reachedJoin() {
        return atJoin;
    }

    @Override
    public void receiveChildResult(long childID, Long val) {
        childResults.set(childIDMap.get(childID), val);
    }

    @Override
    public Long getChildResult(long childID) {
        return childResults.get(childIDMap.get(childID));
    }

    @Override
    public void mergeResults(NFJTask<Long> other) {
        NQueensTask otherNQueens = (NQueensTask) other;

        System.arraycopy(otherNQueens.b, 0, this.b, 0, otherNQueens.b.length);
        this.childResults = otherNQueens.childResults;
        this.childIDMap = otherNQueens.childIDMap;
        this.atJoin = otherNQueens.atJoin;
        this.continuation = otherNQueens.continuation;
    }

}
